(vl-load-com) 
(defun c:po (/ atrybut Dlugosc obj objID pret)
 
  (setq pret (entsel "\nZaznacz pret: "))
  (if pret
    (progn
;; uruchomienie reactora updatujcego dugo polilinii
      (setq obj	    (vlax-ename->vla-object (car pret))
	    objID   (vla-get-objectid obj)
	    Dlugosc (strcat "%<\\AcObjProp Object(%<\\_ObjId "
			    (itoa objID)
			    ">%).Length \\f \"%lu2%pr0%ct8[1]\">%"
		    )
      )
      (setq atrybut (nentsel "\nZaznacz atrybut do podmiany: "))
      (if atrybut
	(if (member (cdr (assoc 0 (entget (car atrybut)))) (list "ATTRIB" "TEXT" "MTEXT"))
	  (progn
	    (vla-put-TextString (vlax-ename->vla-object (car atrybut)) Dlugosc)
	  )
	)
      )
      )
    )
      (princ)
)

;; cytawa&nicer made this
;; lisp do czenia reactorami wartoci dwch wskazanych tekstw
;; tak aby zmiana wartoci jednego automatycznie pocigaa za sob zmian
;; wartoci drugiego
;;  reactor wymaga REGENERACJI rysunku do zmiany wartoci
;;  ================================================================================================
(defun c:pop (/ atrybut obj objID text ent)

  (setq text (nentsel "\nSelect source text: "))
  (if text
    (progn
      (setq ent (car text))
      (if (member (cdr (assoc 0 (entget ent))) (list "ATTRIB" "TEXT" "MTEXT"))
	(progn
	  
	  (setq	obj   (vlax-ename->vla-object ent)
		objid (vla-get-objectid obj)
		linkt (strcat "%<\\AcObjProp Object(%<\\_ObjId "
			      (itoa objid)
			      ">%).TextString>%"
		      )
	  )
	  (setq atrybut (nentsel "\nselect text to link: "))
	  (if atrybut
	    (if	(member	(cdr (assoc 0 (entget (car atrybut))))
			(list "ATTRIB" "TEXT" "MTEXT")
		)
	      (progn
		(command "_undo" "_begin")
		(vla-put-TextString
		  (vlax-ename->vla-object (car atrybut))
		  linkt
		)
		(vla-update (vlax-ename->vla-object (car atrybut)))
		(command "_undo" "_end")
	      )
	    )
	  )
	  
	)
      )
    )
  )
  (princ)
)

;; cytawa&nicer made this
;;  lisp przypisujcy pole powierzchni wskazanej polilinii dowolnie wskazanemu tekstowi
;; reactor automatycznie zmienia warto po zmianie pola powierzchni
;;  reactor wymaga REGENERACJI rysunku do zmiany wartoci
;; ============================================================================================
(defun c:pole (/ atrybut Pole obj objID polilinia)
  (setq polilinia (entsel "\nZaznacz POLILINIE: "))
  (if polilinia
    (progn
      (setq obj	    (vlax-ename->vla-object (car polilinia))
	    objID   (vla-get-objectid obj)
	    Pole (strcat "%<\\AcObjProp Object(%<\\_ObjId "
			    (itoa objID)
				;;  ct8[0.001] wspczynnik skalujcy odczytywan warto
			    ">%).Area \\f \"%lu2%pr1%ct8[0.000001]\">%"
		    )
      )
      (setq atrybut (nentsel "\nZaznacz atrybut lub text do podmiany: "))
      (if atrybut
	(if (member (cdr (assoc 0 (entget (car atrybut)))) (list "ATTRIB" "TEXT" "MTEXT"))
	  (progn
	    (vla-put-TextString (vlax-ename->vla-object (car atrybut)) Pole)
	  )
	)
      )
      )
    )
      (princ)
)


(defun c:45 (/ tOff plSet pLlst vLst oldDss cAng cDis cPt)

; NOTE 
;                                                                 
;  The distance of the text from a LwPolyline line is equal       
;  of multiplication of system variable 'DIMTXT' (height of       
;  the dimensional text) on a variable 'tOff'. Change this        
;  variable for change this distance.                             

  (setq tOff 1.0)
  
  (princ "\n<<< Select LwPolyline for dimensioning >>> ")
  (if(setq plSet(ssget '((0 . "LWPOLYLINE"))))
    (progn
      (setq pLlst(vl-remove-if 'listp
                         (mapcar 'cadr(ssnamex plSet)))
	    oldDss(getvar "DIMASSOC")
	    ); end if
      (setvar "CMDECHO" 0)
      (command "_.undo" "_be")
      (setvar "DIMASSOC" 2)
      (foreach pl pLlst
	(setq vLst(mapcar '(lambda(x)
		   (trans x 0 1))(mapcar 'cdr
		     (vl-remove-if-not
		       '(lambda(x)(= 10(car x)))(entget pl))))
	      ); end setq
	(if(equal '(70 . 1)(assoc 70(entget pl)))
	  (setq vLst(append vLst(list(car vLst))))
	  ); end if
	(while(< 1(length vLst))
	  (setq cAng(angle(car vLst)(cadr vLst))
	        cDis(/(distance(car vLst)(cadr vLst))2))
	  (if(>=(caar vLst)(caadr vLst))
	    (setq cAng(- cAng pi))
	    ); end if
	  (setq cPt(polar
		     (polar(car vLst)cAng cDis)
		     (+ cAng(* 0.5 pi))(* 0.0(getvar "DIMTXT")))
		); end setq
	  (command "_.dimaligned" "_end" (car vLst)
		   "_end" (cadr vLst) "_none" cPt)
	  (setq vLst(cdr vLst))
	  ); end while
	); end foreach
      (setvar "DIMASSOC" oldDss)
      (command "_.undo" "_e")
      (setvar "CMDECHO" 1)
      ); end progn
    ); end if
  (princ)
  ); end of c:pdim

(defun c:COTAD (/ atrybut DIMTEXT obj objID Measurement)
  (setq Measurement (entsel "\nPOKAZ TEXT WYMIAROWY: "))
  (if Measurement
    (progn
      (setq obj	    (vlax-ename->vla-object (car Measurement))
	    objID   (vla-get-objectid obj)
	    DIMTEXT (strcat "%<\\AcObjProp Object(%<\\_ObjId "
			    (itoa objID)
				">%).Measurement \\f \"%lu2%pr0\">%"
		    )
      )
      (setq atrybut (nentsel "\nZaznacz atrybut lub text do podmiany: "))
      (if atrybut
	(if (member (cdr (assoc 0 (entget (car atrybut)))) (list "ATTRIB" "TEXT" "MTEXT"))
	  (progn
	    (vla-put-TextString (vlax-ename->vla-object (car atrybut)) DIMTEXT)
	  )
	)
      )
      )
    )
      (princ)
)

;----------------------------------------------------------
(defun C:34 (/)
  (graphscr)
  (setvar "cmdecho" 0)

(command "_DIMDEC" "0")
(command "_DIMLFAC" "1")
(command "_DIMRND" "1")
(command "_DIMSD1" "off")
(command "_DIMSD2" "off")
(command "_DIMSE1" "off")
(command "_DIMSE2" "off")
(princ  "\n    Styl dla Konstrukcji")
(princ)
)

(defun C:43 (/)
(command "_DIMSD1" "on")
(command "_DIMSD2" "on")
(command "_DIMSE1" "on")
(command "_DIMSE2" "on")
(princ  "\n    Wymiarowanie preta")
(princ)
)